package tools.explorer;

import org.netkernel.ext.system.representation.IRepDeployedModules;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.IHDSInversion;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IHDSNodeList;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class SpaceExplorerEndpointRedirector extends StandardAccessorImpl
{
	public SpaceExplorerEndpointRedirector()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext context) throws Exception
	{	String id=context.getThisRequest().getArgumentValue("id");
		IRepDeployedModules mods=context.source("active:moduleList", IRepDeployedModules.class);
		String hash=mods.hashForSpaceElement(id);
		if(hash==null)
		{	throw new NKFException("No endpoint found for "+id );			
		}
		else
		{	context.sink("httpResponse:/redirect", "/tools/explore/"+hash);			
		}
	}
	
	
}
