package tools.shutdown;

import org.netkernel.layer0.nkf.INKFRequest;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponse;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.impl.HDSBuilder;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.w3c.dom.Document;

public class RebootAccessor extends StandardAccessorImpl
{
	public void onSource(INKFRequestContext aContext) throws Exception
	{
		String mode=aContext.getThisRequest().getArgumentValue("mode");
		IHDSNode params=aContext.source("httpRequest:/params",IHDSNode.class);
		String confirm=(String)params.getFirstValue("confirm");
		String action=(String)params.getFirstValue("action2");
		
		String status;
		boolean needsConfirm=true;
		if (action!=null)
		{
			boolean go=action.contains("force");
			if (!go)
			{	long confirmTime=Long.parseLong(confirm);
				go=System.currentTimeMillis()-confirmTime<20000;
			}
			if ( go )
			{  confirm="";
				if (mode.contains("reboot"))
				{	org.netkernel.layer0.tools.ShutdownMonitor.requestReboot();
				}
				else if (mode.contains("shutdown"))
				{	org.netkernel.layer0.tools.ShutdownMonitor.requestShutdown();
				}
				status=mode+" requested. Please wait...";
				needsConfirm=false;
			}
			else
			{	status="Confirmation timed out. Please try again.";
			}
		}
		else
		{	status="Do you really want to "+mode+"?";
		}
		
		if (needsConfirm)
		{	confirm=Long.toString(System.currentTimeMillis());
		}
		
		INKFRequest req=aContext.createRequest("active:xslt");
		req.addArgument("operator", "res:/tools/shutdown/styleReboot.xsl");
		req.addArgumentByValue("operand","<status>"+status+"</status>");
		req.addArgumentByValue("mode",mode);
		req.addArgumentByValue("needsConfirm",needsConfirm);
		req.addArgumentByValue("confirm",confirm);
		req.setRepresentationClass(Document.class);
		INKFResponseReadOnly respIn=aContext.issueRequestForResponse(req);
		INKFResponse resp=aContext.createResponseFrom(respIn);
		resp.setHeader("WrappedControlPanel", true);
		
		
		//org.netkernel.layer0.tools.ShutdownMonitor.requestReboot();
		//org.netkernel.layer0.tools.ShutdownMonitor.requestShutdown();
	}
}
